class UtmGenerator
  include ActiveModel::Model
  attr_accessor :url, :utm_source, :utm_medium, :utm_campaign, :utm_term, :utm_content

  validates_presence_of :url, :utm_source


  def generate_url
    if valid?
      uri = URI(url)
      params = []
      params << [:utm_source, utm_source]
      params << [:utm_medium, utm_medium] unless utm_medium.blank?
      params << [:utm_campaign, utm_campaign] unless utm_campaign.blank?
      params << [:utm_term, utm_term] unless utm_term.blank?
      params << [:utm_content, utm_content] unless utm_content.blank?
      uri.query = URI.encode_www_form(params)
      uri.to_s
    end
  end
end
